package com.bcxin.api.interfaces.tenants.responses;

import com.bcxin.Infrastructures.enums.MasterSlaveType;
import lombok.Getter;

import java.io.Serializable;
import java.util.Map;

@Getter
public class UserOrganBasicGetResponse implements Serializable {
    private final String organizationId;
    private final String employeeId;
    private final String name;
    private final MasterSlaveType masterSlaveType;
    private final Map<String,Object> additional;
    private final boolean isDomainAdmin;
    private boolean isDepartAdmin = false;
    private String areaCode;
    private String cid;
    public UserOrganBasicGetResponse(String organizationId, String employeeId, String name,
                                     MasterSlaveType masterSlaveType, Map<String, Object> additional, boolean isDomainAdmin,
                                     boolean isDepartAdmin,
                                     String areaCode,
                                     String cid) {
        this.organizationId = organizationId;
        this.employeeId = employeeId;
        this.name = name;
        this.masterSlaveType = masterSlaveType;
        this.additional = additional;
        this.isDomainAdmin = isDomainAdmin;
        this.isDepartAdmin = isDepartAdmin;
        this.areaCode = areaCode;
        this.cid = cid;
    }

    public static UserOrganBasicGetResponse create(String organizationId, String employeeId,String name,
                                                   MasterSlaveType masterSlaveType,Map<String,Object> additional, boolean isDomainAdmin,
                                                   boolean isDepartAdmin,
                                                   String areaCode,
                                                   String cid
                                                   ) {
        return new UserOrganBasicGetResponse(organizationId, employeeId, name, masterSlaveType,additional, isDomainAdmin,
        isDepartAdmin,
        areaCode,cid);
    }
}
